<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
     
      <el-form-item label="计量器具名称" prop="measureName">
        <el-input v-model="formData.measureName" placeholder="请输入计量器具名称" />
      </el-form-item>
      <el-form-item label="分类" prop="classify">
        <el-input v-model="formData.classify" placeholder="请输入分类" />
      </el-form-item>
      <el-form-item label="责任人" prop="dutyPerson">
        <el-input v-model="formData.dutyPerson" placeholder="请输入责任人" />
      </el-form-item>
      <el-form-item label="采购日期" prop="buyDate">
        <el-date-picker
          v-model="formData.buyDate"
          type="date"
          value-format="x"
          placeholder="选择采购日期"
        />
      </el-form-item>
      <el-form-item label="品牌" prop="brand">
        <el-input v-model="formData.brand" placeholder="请输入品牌" />
      </el-form-item>
      <el-form-item label="规格型号" prop="modelName">
        <el-input v-model="formData.modelName" placeholder="请输入规格型号" />
      </el-form-item>
      <el-form-item label="有效期" prop="validity">
        <el-date-picker
          v-model="formData.validity"
          type="date"
          value-format="x"
          placeholder="选择有效期"
        />
      </el-form-item>
      <el-form-item label="上次检验/校准日期" prop="lastTime">
        <el-date-picker
          v-model="formData.lastTime"
          type="date"
          value-format="x"
          placeholder="选择上次检验/校准日期"
        />
      </el-form-item>
      <el-form-item label="单位" prop="measureUnit">
        <el-input v-model="formData.measureUnit" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="价格" prop="measurePrice">
        <el-input v-model="formData.measurePrice" placeholder="请输入价格" />
      </el-form-item>
      <el-form-item label="图片" prop="measurePic">
        <el-input v-model="formData.measurePic" placeholder="请输入图片" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="部门id" prop="deptId">
        <el-input v-model="formData.deptId" placeholder="请输入部门id" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotMeasureBookApi, IotMeasureBookVO } from '@/api/rq/iotmeasurebook'

/** 计量器具台账 表单 */
defineOptions({ name: 'IotMeasureBookForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  // measureCode: undefined,
  measureName: undefined,
  classify: undefined,
  dutyPerson: undefined,
  buyDate: undefined,
  brand: undefined,
  modelName: undefined,
  validity: undefined,
  lastTime: undefined,
  measureUnit: undefined,
  measurePrice: undefined,
  measurePic: undefined,
  remark: undefined,
  deptId: undefined,
})
const formRules = reactive({
  // measureCode: [{ required: true, message: '计量器具编码不能为空', trigger: 'blur' }],
  measureName: [{ required: true, message: '计量器具名称不能为空', trigger: 'blur' }],
  classify: [{ required: true, message: '分类不能为空', trigger: 'blur' }],
  dutyPerson: [{ required: true, message: '责任人不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotMeasureBookApi.getIotMeasureBook(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotMeasureBookVO
    if (formType.value === 'create') {
      await IotMeasureBookApi.createIotMeasureBook(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotMeasureBookApi.updateIotMeasureBook(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    // measureCode: undefined,
    measureName: undefined,
    classify: undefined,
    dutyPerson: undefined,
    buyDate: undefined,
    brand: undefined,
    modelName: undefined,
    validity: undefined,
    lastTime: undefined,
    measureUnit: undefined,
    measurePrice: undefined,
    measurePic: undefined,
    remark: undefined,
    deptId: undefined,
  }
  formRef.value?.resetFields()
}
</script>